﻿/*
NAME: Remove Non-Dark Text Overprint Fill

This script based on ImportTG.jsx script by Oleg Butrin. toolbox.rudtp.ru

AUTHOR: Vlad Ossipov (pp.ossipov@inbox.ru)
HOMEPAGE: http://ossipov.info
DATE  : 05.07.2006 16:41

COMMENT:
Script removes overprint fill attribute from characters which has color different from C0 M0 Y0 K 95-100

Скрипт отменяет атрибут Overprint Fill для текста, если заливка символов отвечает следующим условиям:
- покрашен в Swatch, в котором значение Black < 95
- или с Tint < 95 при любом другом значении Black в Swatch (95 - порогоовое значение по умолчанию, которое можно изменить в .ini файле)
Скрипт обрабатывает выделенные текстовые фреймы, если ничего не выделено, то будет обрабатываться весь документ.
В таком случае, обрабатываются все тексты, на всех слоях (в том числе скрытых и "залоченых").

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.
*/


with (app) {
//Подключаем ini файл
	var iniFile = new File (activeScript.path+ "/rndtof.ini");
	if (iniFile.exists) {
		eval ("//@include \'rndtof.ini\';");
	} else {
		alert("Can\'t open ini file!");
		exit();
	}
//Подключаем lang файл
	var myLangFile = new File (activeScript.path + "/" + iniLangFile);
	if (myLangFile.exists) {
		eval ("//@include \'" + iniLangFile + "\';");
	} else {
		alert ("Cant open lang file!");
		exit();
	}
//Проверяем наличие открытого документа и одного выделенного объекта текстового типа
	if (documents.length < 1) {
		alert(langNoDoc);
		exit();
	}
	if (selection.length < 1) {
		myStories = activeDocument.stories
	}
	if (selection.length > 0) {
		s = 0; i = 0;
		var myStories = new Array;
		while (s < selection.length){
			switch(selection[s].constructor.name) {
				case "TextFrame":
					myStories[i] = selection[s].parentStory;
					i++;
					break;
				case "Text":
					myStories[i] = selection[s].parentStory;
					i++;					
					break;
				case "InsertionPoint":
					myStories[i] = selection[s].parentStory;
					i++;					
					break;
			}
			s++
		}
	}

	for (currentStory = 0; currentStory < myStories.length; currentStory++){
		myStory = myStories[currentStory];
		for (currentChar = 0; currentChar < myStory.characters.length; currentChar++ ){
			colorArray = myStory.characters[currentChar].fillColor.colorValue;
			if ((colorArray[3]<iniLowDark) || ((myStory.characters[currentChar].fillTint > -1) && (myStory.characters[currentChar].fillTint < iniLowDark))) {
				myStory.characters[currentChar].overprintFill = 0
			}
		}
	}
	
	alert (langDone);
}